#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

//TODO: Use the declarative directive that specifies that functions 
//      are mapped to a device
#pragma omp declare target
void print_hello();
#pragma omp end declare target

void
print_hello()
{
//TODO: Use the __MIC__ Macro here to print
//"Hello from Host" on the host and
//"Hello from Phi" on the coprocessor.
#ifdef __MIC__
    printf( "Hello from Phi!\n" );
#else
    printf( "Hello from HOST!\n" );
#endif

    return;
}

int
main( int argc, char** argv )
{
// Hello function is called on the host.
    print_hello();

// The same function shall be called in an offload region.
// TODO: Add an target pragma to execute the next function
// on the coprocessor.
#pragma omp target
    print_hello();

    return 0;
}
