#include <stdio.h>

#define N 1000000000
double calcpi()
{
	int i;
	double pi = 0.0;
	const double h = 1.0 / N;
	#pragma omp parallel for reduction(+:pi) shared(h)
	for( i = 0; i < N; i++ )
	{
		double x = (i+0.5)*h;
		pi += ( 4.0 / (x*x + 1) ) * h;
	}
	return pi;
}

int main( int argc, char **argv )
{
	double pi = calcpi();
	printf("PI is approximately: %f\n", pi);
	return 0;
}

